#include <sourcemod>
#include <cstrike>
#include <sdktools>
#include <sdkhooks>
#include <multicolors>
#include <autoexecconfig>
#include <sdktools_functions>

#pragma newdecls required

#pragma semicolon 1

#define DEBUG

char g_ChatPrefix[256];
ConVar gConVar_Chat_Prefix;

//START ROUND

ConVar gConVar_Health;
ConVar gConVar_Armor;
ConVar gConVar_Helmet;

ConVar gConVar_HE;
ConVar gConVar_Smoke;
ConVar gConVar_FlashBang;
ConVar gConVar_Molotov;

//MONEY HP

int m_iAccount = -1;
int m_iHealth = -1;

//MAX MONEY
bool g_CSGO;

//HP
ConVar gConVar_HP;
ConVar gConVar_HP_HS;
ConVar gConVar_HP_Knife;
ConVar gConVar_Max_HP;

//MONEY
ConVar gConVar_Money;
ConVar gConVar_Money_HS;
ConVar gConVar_Money_Knife;
ConVar gConVar_Max_Money;

//HP BOOL
ConVar gConVar_HP_Bool;
ConVar gConVar_HP_HS_Bool;
ConVar gConVar_HP_Knife_Bool;

//MONEY BOOL
ConVar gConVar_Money_Bool;
ConVar gConVar_Money_HS_Bool;
ConVar gConVar_Money_Knife_Bool;

//MESSAGES
ConVar gConVar_Money_Message;
ConVar gConVar_HP_Message;
ConVar gConVar_Grenades_Messages;
ConVar gConVar_Health_Armor_Helmet_Messages;

//FIRSTROUND
int FirstRound;
ConVar gConVar_FirstRound;
ConVar gConVar_FirstRoundMessage;

//BHOP
Handle gConVar_AutoBunnyHopping = INVALID_HANDLE;
ConVar gConVar_Bhop;

public Plugin myinfo = 
{
	name = "Benefits VIP", 
	author = "LanteJoula", 
	description = "Benefits VIP", 
	version = "1.1", 
	url = "http://steamcommunity.com/id/lantejoula"
};

//PLUGIN
//PLUGIN
//PLUGIN

public void OnPluginStart()
{
	//TRANSLATIONS
	LoadTranslations("benefitsvip.phrases");
	
	AutoExecConfig_SetFile("plugin.benefitsvip");
	
	//CHAT PREFIX
	gConVar_Chat_Prefix = AutoExecConfig_CreateConVar("sm_benefitsvip_chat_prefix", "[{green}TAG{default}]", "Chat Prefix");
	
	//HEALTH ARMOR HELMET
	gConVar_Health = AutoExecConfig_CreateConVar("sm_benefitsvip_health", "110", "Amount of Health when Start Round for VIPS ( Default CSGO = 100 )", 0, true, 1.0, true, 1000.0);
	gConVar_Armor = AutoExecConfig_CreateConVar("sm_benefitsvip_Armor", "120", "Amount of Armor when Start Round for VIPS ( Default CSGO = 100 | Without Armor = 0 )", 0, true, 0.0, true, 1000.0);
	gConVar_Helmet = AutoExecConfig_CreateConVar("sm_benefitsvip_helmet", "1", "VIPS have Helmet when Start Round? ( 1 = With Helmet | 0 = Without Helmet )", 0, true, 0.0, true, 1.0);
	
	//GRENADES
	gConVar_HE = AutoExecConfig_CreateConVar("sm_benefitsvip_he", "1", "Enable/Disable the HE Grenade for VIPS on Round Start (1 - Enable | 0 - Disable)", 0, true, 0.0, true, 1.0);
	gConVar_Smoke = AutoExecConfig_CreateConVar("sm_benefitsvip_smoke", "1", "Enable/Disable the SMOKE Grenade for VIPS on Round Start (1 - Enable | 0 - Disable)", 0, true, 0.0, true, 1.0);
	gConVar_FlashBang = AutoExecConfig_CreateConVar("sm_benefitsvip_flashbang", "1", "Enable/Disable the FLASHBANGS Grenade for VIPS on Round Start (1 - Enable | 0 - Disable)", 0, true, 0.0, true, 1.0);
	gConVar_Molotov = AutoExecConfig_CreateConVar("sm_benefitsvip_molotov", "1", "Enable/Disable the MOLOTOV Grenade for VIPS on Round Start (1 - Enable | 0 - Disable)", 0, true, 0.0, true, 1.0);
	
	//HP
	gConVar_HP = AutoExecConfig_CreateConVar("sm_benefitsvip_kill_bonus_hp", "5", "How much hp VIPS will get for killing", 0, true, 0.0, true, 1000.0);
	gConVar_HP_HS = AutoExecConfig_CreateConVar("sm_benefitsvip_kill_bonus_hp_hs", "7", "How much hp VIPS will get for headshot killing", 0, true, 0.0, true, 1000.0);
	gConVar_HP_Knife = AutoExecConfig_CreateConVar("sm_benefitsvip_kill_bonus_hp_knife", "10", "How much hp VIPS will get for killing by knifE", 0, true, 0.0, true, 1000.0);
	gConVar_Max_HP = AutoExecConfig_CreateConVar("sm_benefitsvip_kill_bonus_max_hp", "150", "How much max hp can a VIPS get for killing", 0, true, 100.0, true, 1000.0);
	
	//MONEY
	gConVar_Money = AutoExecConfig_CreateConVar("sm_benefitsvip_kill_bonus_money", "100", "How much money VIPS will get for killing", 0, true, 0.0, true, 16000.0);
	gConVar_Money_HS = AutoExecConfig_CreateConVar("sm_benefitsvip_kill_bonus_money_hs", "150", "How much money VIPS will get for headshot killing", 0, true, 0.0, true, 16000.0);
	gConVar_Money_Knife = AutoExecConfig_CreateConVar("sm_benefitsvip_kill_bonus_money_knife", "300", "How much money VIPS will get for killing by knife", 0, true, 0.0, true, 16000.0);
	gConVar_Max_Money = g_CSGO ? FindConVar("mp_maxmoney") : AutoExecConfig_CreateConVar("sm_benefitsvip_kill_bonus_max_money", "16000", "How much max money can a VIPS get for killing", 0, true, 0.0, true, 16000.0);
	
	//HP BOOL
	gConVar_HP_Bool = AutoExecConfig_CreateConVar("sm_benefitsvip_kill_bonus_hp_bool", "1", "Enable/Disable VIPS earn HP when they kill (1 - Enable | 0 - Disable)", 0, true, 0.0, true, 1.0);
	gConVar_HP_HS_Bool = AutoExecConfig_CreateConVar("sm_benefitsvip_kill_bonus_hp_hs_bool", "1", "Enable/Disable VIPS earn HP when they kill with headshot (1 - Enable | 0 - Disable)", 0, true, 0.0, true, 1.0);
	gConVar_HP_Knife_Bool = AutoExecConfig_CreateConVar("sm_benefitsvip_kill_bonus_hp_knife_bool", "1", "Enable/Disable VIPS earn HP when they kill with knife (1 - Enable | 0 - Disable)", 0, true, 0.0, true, 1.0);
	
	//MONEY BOOL
	gConVar_Money_Bool = AutoExecConfig_CreateConVar("sm_benefitsvip_kill_bonus_money_bool", "1", "Enable/Disable VIPS earn Money when they kill (1 - Enable | 0 - Disable)", 0, true, 0.0, true, 1.0);
	gConVar_Money_HS_Bool = AutoExecConfig_CreateConVar("sm_benefitsvip_kill_bonus_money_hs_bool", "1", "Enable/Disable VIPS earn Money when they kill with headshot (1 - Enable | 0 - Disable)", 0, true, 0.0, true, 1.0);
	gConVar_Money_Knife_Bool = AutoExecConfig_CreateConVar("sm_benefitsvip_kill_bonus_money_knife_bool", "1", "Enable/Disable VIPS earn Money when they kill with knife (1 - Enable | 0 - Disable)", 0, true, 0.0, true, 1.0);
	
	//MESSAGES
	gConVar_Money_Message = AutoExecConfig_CreateConVar("sm_benefitsvip_money_message", "1", "Enable/Disable Money Messages when VIPS get kills (1 - Enable | 0 - Disable)", 0, true, 0.0, true, 1.0);
	gConVar_HP_Message = AutoExecConfig_CreateConVar("sm_benefitsvip_hp_message", "1", "Enable/Disable HP Messages when VIPS get kills (1 - Enable | 0 - Disable)", 0, true, 0.0, true, 1.0);
	gConVar_Grenades_Messages = AutoExecConfig_CreateConVar("sm_benefitsvip_grenades_message", "1", "Enable/Disable Grenades Messages when VIPS spawn (1 - Enable | 0 - Disable)", 0, true, 0.0, true, 1.0);
	gConVar_Health_Armor_Helmet_Messages = AutoExecConfig_CreateConVar("sm_benefitsvip_health_armor_helmet_message", "1", "Enable/Disable Grenades Messages when VIPS spawn (1 - Enable | 0 - Disable)", 0, true, 0.0, true, 1.0);
	
	//FIRST ROUND
	gConVar_FirstRound = AutoExecConfig_CreateConVar("sm_benefitsvip_firstround", "1", "Enable/Disable VIPs DO NOT receive Benefits on First Round (1 - Enable | 0 - Disable)", 0, true, 0.0, true, 1.0);
	gConVar_FirstRoundMessage = AutoExecConfig_CreateConVar("sm_benefitsvip_firstround_message", "1", "Enable/Disable Message for VIPS when DO NOT receive Benefits on First Round (1 - Enable | 0 - Disable)", 0, true, 0.0, true, 1.0);
	
	//BHOP
	gConVar_Bhop = AutoExecConfig_CreateConVar("sm_benefitsvip_bhop", "1", "Enable/Disable BHOP for VIPs (1 - Enable | 0 - Disable)", 0, true, 0.0, true, 1.0);
	
	AutoExecConfig_ExecuteFile();
	AutoExecConfig_CleanFile();
	
	gConVar_Chat_Prefix.AddChangeHook(OnPrefixChange);
	
	//MONEY HP
	m_iAccount = FindSendPropInfo("CCSPlayer", "m_iAccount");
	m_iHealth = FindSendPropInfo("CCSPlayer", "m_iHealth");
	
	//PLAYER DEATH
	HookEventEx("player_death", Event_PlayerDeath);
	
	//PLAYER SPAWN
	HookEvent("player_spawn", OnPlayerSpawn);
	
	//START ROUND
	HookEvent("round_start", OnRoundStart);
	
	//BHOP
	gConVar_AutoBunnyHopping = FindConVar("sv_autobunnyhopping");
	SetConVarBool(gConVar_AutoBunnyHopping, false);
}

//Prefix

public void SavePrefix()
{
	GetConVarString(gConVar_Chat_Prefix, g_ChatPrefix, sizeof(g_ChatPrefix));
}

public void OnConfigsExecuted()
{
	SavePrefix();
}

public void OnPrefixChange(ConVar cvar, char[] oldvalue, char[] newvalue)
{
	SavePrefix();
}

//START ROUND

public Action OnPlayerSpawn(Event event, const char[] sName, bool bDontBroadCast)
{
	int client = GetClientOfUserId(event.GetInt("userid"));
	
	if (IsWarmup())
	{
		return;
	}
	
	if (CheckCommandAccess(client, "sm_benefitsvip_override_vip", ADMFLAG_CUSTOM1))
	{
		if (FirstRound < 0)
		{
			//BHOP
			if (gConVar_Bhop.BoolValue)
				SendConVarValue(client, gConVar_AutoBunnyHopping, "1");
			
			//FREE HEALTH/ARMOR/HELMET
			
			char messageno[16];
			Format(messageno, sizeof(messageno), "%t", "No");
			
			char messageyes[16];
			Format(messageyes, sizeof(messageyes), "%t", "Yes");
			
			char message[200];
			Format(message, sizeof(message), "%s %t", g_ChatPrefix, "RoundStartHealthHelmetArmor", gConVar_Health.IntValue, gConVar_Armor.IntValue, gConVar_Helmet.BoolValue ? messageyes:messageno);
			
			if (gConVar_Health_Armor_Helmet_Messages.BoolValue)
			{
				if (gConVar_Health.IntValue != 100 || gConVar_Armor.IntValue != 100 || gConVar_Helmet.IntValue != 0)
					CPrintToChat(client, message);
			}
			
			//HEALTH
			SetEntProp(client, Prop_Send, "m_iHealth", gConVar_Health.IntValue);
			
			//ARMOR
			SetEntProp(client, Prop_Send, "m_ArmorValue", gConVar_Armor.IntValue);
			
			//HELMET
			SetEntProp(client, Prop_Send, "m_bHasHelmet", gConVar_Helmet.IntValue);
			
			
			//FREE GRENADES
			RemoveNades(client);
			
			if (gConVar_HE.BoolValue)
			{
				GivePlayerItem(client, "weapon_hegrenade");
				
				if (gConVar_Grenades_Messages.BoolValue)
					CPrintToChat(client, "%s %t", g_ChatPrefix, "HeMessage");
			}
			
			if (gConVar_Smoke.BoolValue)
			{
				GivePlayerItem(client, "weapon_smokegrenade");
				
				if (gConVar_Grenades_Messages.BoolValue)
					CPrintToChat(client, "%s %t", g_ChatPrefix, "SmokeMessage");
			}
			
			if (gConVar_FlashBang.BoolValue)
			{
				GivePlayerItem(client, "weapon_flashbang");
				
				if (gConVar_Grenades_Messages.BoolValue)
					CPrintToChat(client, "%s %t", g_ChatPrefix, "FlashBangMessage");
			}
			
			if (gConVar_Molotov.BoolValue)
			{
				GivePlayerItem(client, "weapon_molotov");
				
				if (gConVar_Grenades_Messages.BoolValue)
					CPrintToChat(client, "%s %t", g_ChatPrefix, "MolotovMessage");
			}
		}
	}
}

//REMOVE NADES

#define MAX_NADES 6

int grenade_offsets[] = { 15, 17, 16, 14, 18, 17 };

stock void RemoveNades(int client)
{
	while (RemoveWeaponBySlot(client, 3)) {  }
	for (int i = 0; i < MAX_NADES; i++)
	SetEntProp(client, Prop_Send, "m_iAmmo", 0, _, grenade_offsets[i]);
}

stock bool RemoveWeaponBySlot(int client, int slot)
{
	int ent = GetPlayerWeaponSlot(client, slot);
	
	if (IsValidEdict(ent))
	{
		RemovePlayerItem(client, ent);
		AcceptEntityInput(ent, "Kill");
		return true;
	}
	
	return false;
}

//PLAYER SPAWN

public void Event_PlayerDeath(Event event, const char[] sEvName, bool bDontBroadcast)
{
	int client = GetClientOfUserId(GetEventInt(event, "userid"));
	int attacker = GetClientOfUserId(GetEventInt(event, "attacker"));
	
	if (IsWarmup())
	{
		return;
	}
	
	if (CheckCommandAccess(attacker, "sm_benefitsvip_override_vip", ADMFLAG_CUSTOM1))
	{
		if (FirstRound < 0)
		{
			//HP AND MONEY
			if (attacker)
			{
				if (attacker != client && GetClientTeam(client) != GetClientTeam(attacker))
				{
					if (GetEventBool(event, "headshot"))
					{
						if (gConVar_HP_HS_Bool.BoolValue)
						{
							client = GiveClientData(attacker, m_iHealth, gConVar_HP_HS.IntValue, gConVar_Max_HP.IntValue);
							
							if (gConVar_HP_Message.BoolValue)
								CPrintToChat(attacker, "%s %t", g_ChatPrefix, "HSKillHPMessage", gConVar_HP_HS.IntValue);
						}
						
						if (gConVar_Money_HS_Bool.BoolValue)
						{
							client = GiveClientData(attacker, m_iAccount, gConVar_Money_HS.IntValue, gConVar_Max_Money.IntValue);
							
							if (gConVar_Money_Message.BoolValue)
								CPrintToChat(attacker, "%s %t", g_ChatPrefix, "HSKillMoneyMessage", gConVar_Money_HS.IntValue);
						}
						
						if (client)
						{
							return;
						}
					}
					
					char weapon[64];
					GetEventString(event, "weapon", weapon, sizeof(weapon));
					ReplaceString(weapon, sizeof(weapon), "weapon_", "");
					
					if (StrContains(weapon, "knife") != -1 || StrEqual(weapon, "bayonet") || StrEqual(weapon, "melee") || StrEqual(weapon, "axe") || StrEqual(weapon, "hammer") || StrEqual(weapon, "spanner") || StrEqual(weapon, "fists"))
						weapon = "knife";
					
					if (StrEqual(weapon, "knife"))
					{
						if (gConVar_HP_Knife_Bool.BoolValue)
						{
							client = GiveClientData(attacker, m_iHealth, gConVar_HP_Knife.IntValue, gConVar_Max_HP.IntValue);
							
							if (gConVar_HP_Message.BoolValue)
								CPrintToChat(attacker, "%s %t", g_ChatPrefix, "KnifeKillHPMessage", gConVar_HP_Knife.IntValue);
						}
						
						if (gConVar_Money_Knife_Bool.BoolValue)
						{
							client = GiveClientData(attacker, m_iAccount, gConVar_Money_Knife.IntValue, gConVar_Max_Money.IntValue);
							
							if (gConVar_Money_Message.BoolValue)
								CPrintToChat(attacker, "%s %t", g_ChatPrefix, "KnifeKillMoneyMessage", gConVar_Money_Knife.IntValue);
						}
						
						if (client)
						{
							return;
						}
					}
					
					if (gConVar_HP_Bool.BoolValue)
					{
						GiveClientData(attacker, m_iHealth, gConVar_HP.IntValue, gConVar_Max_HP.IntValue);
						
						if (gConVar_HP_Message.BoolValue)
							CPrintToChat(attacker, "%s %t", g_ChatPrefix, "KillHPMessage", gConVar_HP.IntValue);
					}
					
					if (gConVar_Money_Bool.BoolValue)
					{
						GiveClientData(attacker, m_iAccount, gConVar_Money.IntValue, gConVar_Max_Money.IntValue);
						
						if (gConVar_Money_Message.BoolValue)
							CPrintToChat(attacker, "%s %t", g_ChatPrefix, "KillMoneyMessage", gConVar_Money.IntValue);
					}
				}
			}
		}
	}
}


int GiveClientData(int client, int m_Offset, int iValue, int iMaxValue)
{
	if (iValue > 0)
	{
		iValue += GetEntData(client, m_Offset);
		
		if (iValue > iMaxValue)
		{
			iValue = iMaxValue;
		}
		
		SetEntData(client, m_Offset, iValue);
		
		return 1;
	}
	
	return 0;
}

//FIRST ROUND

public void OnMapStart()
{
	if (gConVar_FirstRound.BoolValue)
	{
		FirstRound = 1;
	}
	else
	{
		FirstRound = -1;
	}
}

public Action OnRoundStart(Event event, const char[] name, bool dontBroadcast)
{
	int client = GetClientOfUserId(GetEventInt(event, "userid"));
	
	if (IsWarmup())
	{
		return;
	}
	
	if (gConVar_FirstRound.BoolValue)
	{
		if (FirstRound >= 0)
		{
			FirstRound--;
		}
		
		if (gConVar_FirstRoundMessage.BoolValue)
		{
			CPrintToChat(client, "%s %t", g_ChatPrefix, "FirstRoundMessage");
		}
	}
}

//BHOP

public Action OnPlayerRunCmd(int client, int & buttons, int & impulse, float vel[3], float angles[3], int & weapon, int & subtype, int & cmdnum, int & tickcount, int & seed, int mouse[2])
{
	if (IsWarmup())
	{
		return;
	}
	
	if (gConVar_Bhop.BoolValue)
	{
		if (IsPlayerAlive(client))
		{
			if (CheckCommandAccess(client, "sm_benefitsvip_override_vip", ADMFLAG_CUSTOM1))
			{
				if (FirstRound < 0)
				{
					if (buttons & IN_JUMP)
					{
						if (!(GetEntityFlags(client) & FL_ONGROUND))
						{
							if (!(GetEntityMoveType(client) & MOVETYPE_LADDER))
							{
								if (GetEntProp(client, Prop_Data, "m_nWaterLevel") <= 1)
								{
									buttons &= ~IN_JUMP;
								}
							}
						}
					}
				}
			}
		}
	}
}

//WARMUP

stock bool IsWarmup()
{
	return GameRules_GetProp("m_bWarmupPeriod") == 1;
} 